// CLIKCLOK.CPP - TClickClock functions

#define Uses_TEvent
#define Uses_TRect
#define Uses_TView
#define Uses_TDrawBuffer
#include <tv.h>

#include <string.h>
#include <stdlib.h>
#include <time.h>

#include "clikclok.h"

TClickClock::TClickClock( TRect& r, Boolean TwelveH ) : TView( r )
{
	strcpy( lastTime, "          " );
	strcpy( curTime, "          " );
	TwelveHour = TwelveH;
}

void TClickClock::handleEvent( TEvent& event )
{
	if( event.what == evMouseDown ) {
		if( event.mouse.doubleClick ) {
			TwelveHour = Boolean( !TwelveHour );
			update();
		}
	}
	TView::handleEvent( event );
}

void TClickClock::draw()
{
	TDrawBuffer buf;
	char c = getColor(2);

	buf.moveChar(0, ' ', c, size.x);
	buf.moveStr(0, curTime, c);
	writeLine(0, 0, size.x, 1, buf);
}

void TClickClock::update()
{
	time_t t = time(0);
	char *date = ctime(&t);

	date[19] = '\0';

	if( TwelveHour == True ) {
		char *ampm = "am";
		char hour[3] = "";
		int inthr;
		hour[0] = date[11];
		hour[1] = date[12];
		inthr = atoi( hour );

		if( inthr == 12 ) {
			strcpy( ampm, "pm" );
		}
		else if( inthr > 12 ) {
			inthr -= 12;
			strcpy( ampm, "pm" );
		}
		else if( inthr == 0 ) {
			inthr += 12;
		}

		itoa( inthr, hour, 10 );
		if( inthr > 9 ) {
			date[11] = hour[0];
			date[12] = hour[1];
		}
		else {
			date[11] = ' ';
			date[12] = hour[0];
		}

		strcpy( curTime, &date[11] );        /* Extract time. */
		strcat( curTime, ampm );
	}
	else {
		strcpy( curTime, &date[11] );
	}

	if( strcmp(lastTime, curTime) ) {
		drawView();
		strcpy(lastTime, curTime);
	}
}

